osg::HeightField Class Reference

`#include <Shape>`

Inheritance diagram for osg::HeightField:

## Public Types

typedef std::vector< float > | HeightList
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| HeightField ()
| HeightField (const HeightField &mesh, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Shape (osg, HeightField)
void | allocate (unsigned int numColumns, unsigned int numRows)
unsigned int | getNumColumns () const
unsigned int | getNumRows () const
void | setOrigin (const Vec3 &origin)
const Vec3 & | getOrigin () const
void | setXInterval (float dx)
float | getXInterval () const
void | setYInterval (float dy)
float | getYInterval () const
FloatArray * | getFloatArray ()
const FloatArray * | getFloatArray () const
HeightList & | getHeightList ()
const HeightList & | getHeightList () const
void | setSkirtHeight (float skirtHeight)
float | getSkirtHeight () const
void | setBorderWidth (unsigned int borderWidth)
unsigned int | getBorderWidth () const
void | setRotation (const Quat &quat)
const Quat & | getRotation () const
Matrix | computeRotationMatrix () const
bool | zeroRotation () const
void | setHeight (unsigned int c, unsigned int r, float value)
float & | getHeight (unsigned int c, unsigned int r)
float | getHeight (unsigned int c, unsigned int r) const
Vec3 | getVertex (unsigned int c, unsigned int r) const
Vec3 | getNormal (unsigned int c, unsigned int r) const
Vec2 | getHeightDelta (unsigned int c, unsigned int r) const
Public Member Functions inherited from osg::Shape
| Shape ()
| Shape (const Shape &sa, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
virtual void | accept (ShapeVisitor &)=0
virtual void | accept (ConstShapeVisitor &) const =0
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~HeightField ()
Protected Member Functions inherited from osg::Shape
virtual | ~Shape ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

unsigned int | _columns
unsigned int | _rows
Vec3 | _origin
float | _dx
float | _dy
float | _skirtHeight
unsigned int | _borderWidth
Quat | _rotation
ref_ptr< FloatArray > | _heights
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Member Typedef Documentation

## HeightList

typedef std::vector<float> osg::HeightField::HeightList

## Constructor & Destructor Documentation

## HeightField() [1/2]

osg::HeightField::HeightField | ( |  | ) |

Referenced by HeightField(), and META_Shape().

## HeightField() [2/2]

osg::HeightField::HeightField | ( | const HeightField & | mesh,
|  | const CopyOp & | copyop = CopyOp::SHALLOW_COPY )

References HeightField(), and osg::CopyOp::SHALLOW_COPY.

## ~HeightField()

virtual osg::HeightField::~HeightField | ( |  | ) |

protected virtual

## Member Function Documentation

## allocate()

void osg::HeightField::allocate | ( | unsigned int | numColumns,
|  | unsigned int | numRows )

## computeRotationMatrix()

Matrix osg::HeightField::computeRotationMatrix | ( |  | ) | const

inline

References _rotation.

## getBorderWidth()

unsigned int osg::HeightField::getBorderWidth | ( |  | ) | const

inline

Get the width in number of cells in from the edge that the height field should be rendered from.

References _borderWidth.

## getFloatArray() [1/2]

FloatArray * osg::HeightField::getFloatArray | ( |  | ) |

inline

Get the FloatArray height data.

References _heights.

## getFloatArray() [2/2]

const FloatArray * osg::HeightField::getFloatArray | ( |  | ) | const

inline

Get the const FloatArray height data.

References _heights.

## getHeight() [1/2]

float & osg::HeightField::getHeight | ( | unsigned int | c,
|  | unsigned int | r )

inline

References _columns, and _heights.

## getHeight() [2/2]

float osg::HeightField::getHeight | ( | unsigned int | c,
|  | unsigned int | r ) const

inline

References _columns, and _heights.

## getHeightDelta()

Vec2 osg::HeightField::getHeightDelta | ( | unsigned int | c,
|  | unsigned int | r ) const

## getHeightList() [1/2]

HeightList & osg::HeightField::getHeightList | ( |  | ) |

inline

References _heights.

## getHeightList() [2/2]

const HeightList & osg::HeightField::getHeightList | ( |  | ) | const

inline

References _heights.

## getNormal()

Vec3 osg::HeightField::getNormal | ( | unsigned int | c,
|  | unsigned int | r ) const

## getNumColumns()

unsigned int osg::HeightField::getNumColumns | ( |  | ) | const

inline

References _columns.

## getNumRows()

unsigned int osg::HeightField::getNumRows | ( |  | ) | const

inline

References _rows.

## getOrigin()

const Vec3 & osg::HeightField::getOrigin | ( |  | ) | const

inline

References _origin.

## getRotation()

const Quat & osg::HeightField::getRotation | ( |  | ) | const

inline

References _rotation.

## getSkirtHeight()

float osg::HeightField::getSkirtHeight | ( |  | ) | const

inline

Get the height of the skirt to render around the edge of HeightField.

References _skirtHeight.

## getVertex()

Vec3 osg::HeightField::getVertex | ( | unsigned int | c,
|  | unsigned int | r ) const

inline

References _columns, _heights, _origin, getXInterval(), and getYInterval().

## getXInterval()

float osg::HeightField::getXInterval | ( |  | ) | const

inline

References _dx.

Referenced by getVertex().

## getYInterval()

float osg::HeightField::getYInterval | ( |  | ) | const

inline

References _dy.

Referenced by getVertex().

## META_Shape()

osg::HeightField::META_Shape | ( | osg | ,
|  | HeightField | )

References HeightField().

## setBorderWidth()

void osg::HeightField::setBorderWidth | ( | unsigned int | borderWidth | ) |

inline

Set the width in number of cells in from the edge that the height field should be rendered from. This exists to allow gradient and curvature continutity to be maintained between adjacent HeightField, where the border cells will overlap adjacent HeightField.

References _borderWidth.

## setHeight()

void osg::HeightField::setHeight | ( | unsigned int | c,
|  | unsigned int | r,
|  | float | value )

inline

References _columns.

## setOrigin()

void osg::HeightField::setOrigin | ( | const Vec3 & | origin | ) |

inline

References _origin.

## setRotation()

void osg::HeightField::setRotation | ( | const Quat & | quat | ) |

inline

References _rotation.

## setSkirtHeight()

void osg::HeightField::setSkirtHeight | ( | float | skirtHeight | ) |

inline

Set the height of the skirt to render around the edge of HeightField. The skirt is used as a means of disguising edge boundaries between adjacent HeightField, particularly of ones with different resolutions.

References _skirtHeight.

## setXInterval()

void osg::HeightField::setXInterval | ( | float | dx | ) |

inline

References _dx.

## setYInterval()

void osg::HeightField::setYInterval | ( | float | dy | ) |

inline

References _dy.

## zeroRotation()

bool osg::HeightField::zeroRotation | ( |  | ) | const

inline

References _rotation.

## Member Data Documentation

## _borderWidth

unsigned int osg::HeightField::_borderWidth

protected

Referenced by getBorderWidth(), and setBorderWidth().

## _columns

unsigned int osg::HeightField::_columns

protected

Referenced by getHeight(), getHeight(), getNumColumns(), getVertex(), and setHeight().

## _dx

float osg::HeightField::_dx

protected

Referenced by getXInterval(), and setXInterval().

## _dy

float osg::HeightField::_dy

protected

Referenced by getYInterval(), and setYInterval().

## _heights

ref_ptr<FloatArray> osg::HeightField::_heights

protected

Referenced by getFloatArray(), getFloatArray(), getHeight(), getHeight(), getHeightList(), getHeightList(), and getVertex().

## _origin

Vec3 osg::HeightField::_origin

protected

Referenced by getOrigin(), getVertex(), and setOrigin().

## _rotation

Quat osg::HeightField::_rotation

protected

Referenced by computeRotationMatrix(), getRotation(), setRotation(), and zeroRotation().

## _rows

unsigned int osg::HeightField::_rows

protected

Referenced by getNumRows().

## _skirtHeight

float osg::HeightField::_skirtHeight

protected

Referenced by getSkirtHeight(), and setSkirtHeight().

The documentation for this class was generated from the following file:

- Shape